Additional Resources
====================

# Further Reading

- [Marko versus Dust](http://psteeleidem.com/marko-versus-dust/)
- [The JavaScript Templating Landscape](http://psteeleidem.com/the-javascript-templating-landscape/)
- [eBay Tech Blog - Async Fragments: Rediscovering Progressive HTML Rendering with Marko](http://www.ebaytechblog.com/2014/12/08/async-fragments-rediscovering-progressive-html-rendering-with-marko/) *(Note: The article uses Marko v2's `<async-fragment>` which is now deprecated in favor of [`<await>`](http://markojs.com/docs/marko/async-taglib/), however the concepts remain the same)*
- [Marko Widgets](https://github.com/marko-js/marko-widgets) - Taglib to support binding of behavior to rendered UI components rendered on the server or client

# Updates

- [What's New in Marko v3](http://markojs.com/docs/marko/what-is-new-marko-v3/)
- [CHANGELOG](https://github.com/marko-js/marko/blob/master/CHANGELOG.md)

# Screencasts

* [KnowThen: Episode 8 – Serving Content in Koajs with Marko](http://knowthen.com/episode-8-serving-content-in-koajs-with-marko/)

# Sample Apps

* Async Fragments Demo using Marko: In-order versus out-of-order rendering [source](https://github.com/marko-js-samples/marko-progressive-rendering) | [demo](https://marko-progressive-rendering.herokuapp.com/) *(Note: This demo uses `<async-fragment>` which is now deprecated in favor of [`<await>`](http://markojs.com/docs/marko/async-taglib/), however the concepts remain the same)*
* UI Components Playground [source](https://github.com/marko-js-samples/ui-components-playground) | [demo](https://ui-components-playground.herokuapp.com/)
* More sample apps: [https://github.com/marko-js-samples](https://github.com/marko-js-samples)

# Web Server Frameworks

* Use Marko with any web framework:
  * [Express](http://markojs.com/docs/marko/express/)
  * [Koa](http://markojs.com/docs/marko/koa/)
  * [Hapi](http://markojs.com/docs/marko/hapi/)


# Tools

* [Atom Editor](https://atom.io/)
    * [language-marko](https://atom.io/packages/language-marko) - Syntax highlighting for Marko templates in Atom
    * [atom-beautify](https://github.com/Glavin001/atom-beautify) - Beautify Marko templates in Atom
* [Sublime Text](http://www.sublimetext.com/)
    * [marko-sublime](https://github.com/merwan7/sublime-marko) - Syntax highlighting and completions for Sublime Text
* [WebStorm](https://www.jetbrains.com/webstorm/)
    * [marko-tmbundle](https://github.com/marko-js/marko-tmbundle) - Syntax highlighting for Marko templates in WebStorm (see: [Importing TextMate Bundles](https://www.jetbrains.com/phpstorm/help/importing-textmate-bundles.html))
* [TextMate 2/3](https://macromates.com/)
    * [marko-tmbundle](https://github.com/marko-js/marko-tmbundle) - Syntax highlighting for Marko templates in TextMate
